Name: bdii4
Version: 4.0.2.2
Release: 5%{?dist}
Summary: The Berkeley Database Information Index version 4 (BDIIv4)

Group: System Environment/Daemons
License: ASL 2.0
URL: https://twiki.cern.ch/twiki/bin/view/EGEE/BDIIv4
Source: %{name}-%{version}.tar.gz
# Change bdii file locations to standard values
Patch0: bdii.patch
# Add option to turn the bdii self-monitoring service on/off
Patch1: bdii-update.patch
# Allow standard location for BDII_DIR (/usr)
Patch2: bdii-dir.patch
# Allow default configuration to work on all BDB versions out-of-the-box
Patch3: bdii-bdb.patch
# Fix manpages
Patch4: bdii-manpages.patch
BuildArch: noarch
BuildRoot: %{_tmppath}/%{name}-%{version}-build

%if 0%{?suse_version} > 0
Requires: openldap2-client
Requires: openldap2
%else
Requires: openldap-clients
Requires: openldap-servers
%endif
Requires: perl-libwww-perl
Provides: bdii = %version-%release

Requires(post): chkconfig
Requires(preun): chkconfig
Requires(preun): initscripts
Requires(postun): initscripts

%description
The Berkeley Database Information Index version 4 (BDIIv4).

%prep
%setup -q
%patch0 -p1
%patch1 -p1
%patch2 -p1
%patch3 -p1
%patch4 -p1

%build
pod2man -s 5 --center "BDII Configuration" doc/section5 > doc/%{name}.5
pod2man -s 8 --center "BDII Services"      doc/section8 > doc/%{name}.8
chmod -x README

%install
rm -rf $RPM_BUILD_ROOT

mkdir -p ${RPM_BUILD_ROOT}%{_sbindir}
mkdir -p ${RPM_BUILD_ROOT}%{_sysconfdir}/%{name}
mkdir -p ${RPM_BUILD_ROOT}%{_sysconfdir}/logrotate.d
mkdir -p ${RPM_BUILD_ROOT}%{_sysconfdir}/init.d
mkdir -p ${RPM_BUILD_ROOT}%{_mandir}/man5
mkdir -p ${RPM_BUILD_ROOT}%{_mandir}/man8
mkdir -p ${RPM_BUILD_ROOT}%{_localstatedir}/log/%{name}
mkdir -p ${RPM_BUILD_ROOT}%{_localstatedir}/lib/%{name}
mkdir -p ${RPM_BUILD_ROOT}%{_localstatedir}/run/%{name}

install -m 0755 sbin/bdii-fwd ${RPM_BUILD_ROOT}/%{_sbindir}/%{name}-fwd
install -m 0755 sbin/bdii-proxy ${RPM_BUILD_ROOT}/%{_sbindir}/%{name}-proxy
install -m 0755 sbin/bdii-update ${RPM_BUILD_ROOT}/%{_sbindir}/%{name}-update
install -m 0644 etc/logrotate.d/bdii \
                ${RPM_BUILD_ROOT}/%{_sysconfdir}/logrotate.d/%{name}
install -m 0644 etc/bdii.conf ${RPM_BUILD_ROOT}/%{_sysconfdir}/%{name}
install -m 0644 etc/bdii-update.conf ${RPM_BUILD_ROOT}/%{_sysconfdir}/%{name}
install -m 0644 etc/glue-slapd.conf \
                ${RPM_BUILD_ROOT}/%{_sysconfdir}/%{name}/slapd.conf
install -m 0644 etc/DB_CONFIG ${RPM_BUILD_ROOT}/%{_sysconfdir}/%{name}
install -m 0644 etc/default.ldif ${RPM_BUILD_ROOT}/%{_sysconfdir}/%{name}
install -m 0644 etc/BDII.schema ${RPM_BUILD_ROOT}/%{_sysconfdir}/%{name}

install -m 0644 doc/%{name}.5 ${RPM_BUILD_ROOT}/%{_mandir}/man5/%{name}.5
install -m 0644 doc/%{name}.8 ${RPM_BUILD_ROOT}/%{_mandir}/man8/%{name}.8

# Turn off default enabling of the service
mkdir -p $RPM_BUILD_ROOT%{_initrddir}
sed -e 's/\(chkconfig: \)\w*/\1-/' \
    -e '/Default-Start/d' \
    -e 's/\(Default-Stop:\s*\).*/\10 1 2 3 4 5 6/' \
   etc/init.d/bdii > $RPM_BUILD_ROOT%{_initrddir}/%{name}
chmod 0755 $RPM_BUILD_ROOT%{_initrddir}/%{name}

%post
/sbin/chkconfig --add %{name}

%preun
if [ $1 = 0 ]; then
  service %{name} stop > /dev/null 2>&1
  /sbin/chkconfig --del %{name}
fi

%postun
if [ "$1" -ge "1" ]; then
  service %{name} condrestart > /dev/null 2>&1
fi
exit 0

%files
%defattr(-,root,root)
%config(noreplace) %{_sysconfdir}/%{name}/bdii.conf
%config(noreplace) %{_sysconfdir}/%{name}/bdii-update.conf
%config(noreplace) %{_sysconfdir}/%{name}/slapd.conf
%config(noreplace) %{_sysconfdir}/%{name}/BDII.schema
%config(noreplace) %{_sysconfdir}/%{name}/DB_CONFIG
%config(noreplace) %{_sysconfdir}/%{name}/default.ldif
%config(noreplace) %{_sysconfdir}/logrotate.d/%{name}
%doc README
%{_mandir}/man5/%{name}.5*
%{_mandir}/man8/%{name}.8*
%{_initrddir}/%{name}
%{_sbindir}/%{name}-fwd
%{_sbindir}/%{name}-proxy
%{_sbindir}/%{name}-update
%dir %{_localstatedir}/log/%{name}
%dir %{_localstatedir}/lib/%{name}
%dir %{_localstatedir}/run/%{name}

%clean
rm -rf %{buildroot}

%changelog
* Thu Nov 19 2009 Mattias Ellert <mattias.ellert@fysast.uu.se> - 4.0.2.2-5
- Updated bdii4-update.patch from Daniel Johansson
- Fixes a problem with deleting old database files

* Thu Oct 08 2009 Mattias Ellert <mattias.ellert@fysast.uu.se> - 4.0.2.2-4
- Updated patch

* Tue Sep 22 2009 Mattias Ellert <mattias.ellert@fysast.uu.se> - 4.0.2.2-3ng
- Add provides bdii

* Mon Sep 21 2009 Mattias Ellert <mattias.ellert@fysast.uu.se> - 4.0.2.2-2ng
- Add additional patches from Steffen Möller and Daniel Johansson

* Wed Aug 12 2009 Anders Waananen <waananen@nbi.dk> - 4.0.2.2-1ng
- Change name from bdii to bdii4 and update bdii.patch accordingly

* Wed Aug 12 2009 Anders Waananen <waananen@nbi.dk> - 4.0.2-4ng
- Make DB_CONFIG BDB version independent (must be updated to be optimal)
- Add /var/run/bdii to the package
- Add bdii-dir.patch to allow standard locations
- Add bdii-bdb.patch to make it work on all BDB versions out-of-the-box

* Thu Jul 16 2009 Anders Waananen <waananen@nbi.dk> - 4.0.2-3ng
- Specfile rewritten to be more standard compliant
